/*
 * HeadFeaturedChartParser.java
 *
 * George Ferguson, ferguson@cs.rochester.edu, 14 May 2002
 * Time-stamp: <Thu May 22 15:50:00 EDT 2003 ferguson>
 */

/**
 * This is the augmented bottom-up parser described in NLU Chapter 4,
 * with the head feature convention applied to grammar rules.
 * Since this difference only matters as the grammar rules are being
 * added, the only code for this class is a different driver for
 * loading the right kind of grammar (a HeadFeaturedGrammar, in fact).
 */
public class HeadFeaturedChartParser extends AugmentedChartParser {
    /**
     * Test the head-featured bottom-up chart parser.
     */
    public static void main(String argv[]) {
	main(argv, AugmentedLexicon.class, HeadFeaturedGrammar.class, HeadFeaturedChartParser.class);
    }
}
