/*
 * Unifiable.java
 *
 * George Ferguson, ferguson@cs.rochester.edu, 24 Apr 2002
 * Time-stamp: <Wed May 14 12:23:11 EDT 2003 ferguson>
 */

/**
 * Interface implemented by objects that can be unified. Duh.
 */
interface Unifiable {
    /**
     * Attempts to unify two Unifiables. Returns true if successful,
     * possibly modifying the bindings, otherwise false (no guarantee
     * that bindings aren't altered by failed unifications.
     */
    public boolean unifyWith(Unifiable other, BindingSet bindings);
    /**
     * Returns a copy of this Unifiable, with the given bindings applied.
     */
    public Unifiable copyWithBindings(BindingSet bindings);
}

