/*
 * VariableValueSet.java
 *
 * George Ferguson, ferguson@cs.rochester.edu, 24 Apr 2002
 * Time-stamp: <Wed May 14 12:25:44 EDT 2003 ferguson>
 */

import java.util.Iterator;
import java.util.NoSuchElementException;

/**
 * Variables can be constrained by sets of possible values.
 * These are typically small, unchanging sets (although the current
 * implementation doesn't take advantage of that fact).
 */
public class VariableValueSet extends LinkedListSet {
    /**
     * Returns the printable representation of this VariableValueSet as a
     * String (using Lisp list syntax).
     */
    public String toString() {
	return Printing.listToString(iterator());
    }
    /**
     * Return the VariableValueSet representing the intersection of
     * this VariableValueSet with another one.
     */
    public VariableValueSet intersectWith(VariableValueSet other) {
	VariableValueSet result = new VariableValueSet();
	Iterator items = iterator();
	try {
	    while (items.hasNext()) {
		Object item = items.next();
		if (other.contains(item)) {
		    result.add(item);
		}
	    }
	} catch (NoSuchElementException ex) {
	}
	return result;
    }
}
